Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/FileManager.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/FileManager.cs	(revision 17435)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/FileManager.cs	(revision 17436)
@@ -14,5 +14,4 @@
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
   internal static class FileManager {
-    private static SaveFileDialog saveFileDialog;
     private static OpenFileDialog openFileDialog;
     private static ExportJsonDialog exportDialog = new ExportJsonDialog();
@@ -26,33 +25,8 @@
     public static void ExportJsonTemplate(IContentView view) {
       // TODO: view to select free params, warning if no results are generated
-      
-
-
       IStorableContent content = view.Content as IStorableContent;
       if (!view.Locked && content != null) {
         exportDialog.Content = content;
         exportDialog.ShowDialog();
-        /*
-        if (saveFileDialog == null) {
-          saveFileDialog = new SaveFileDialog();
-          saveFileDialog.Title = "Export .json-Template";
-          saveFileDialog.DefaultExt = "json";
-          saveFileDialog.Filter = ".json-Template|*.json|All Files|*.*";
-          saveFileDialog.FilterIndex = 1;
-        }
-
-        INamedItem namedItem = content as INamedItem;
-        string suggestedFileName = string.Empty;
-        if (!string.IsNullOrEmpty(content.Filename)) suggestedFileName = content.Filename;
-        else if (namedItem != null) suggestedFileName = namedItem.Name;
-        else suggestedFileName = "Item";
-
-        saveFileDialog.FileName = suggestedFileName + " " + namedItem.GetType().Name;
-
-        if (saveFileDialog.ShowDialog() == DialogResult.OK) {
-          IAlgorithm alg = namedItem as IAlgorithm;
-          File.WriteAllText(saveFileDialog.FileName, JCGenerator.GenerateTemplate(alg));
-        }
-        */
       }
     }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.cs	(revision 17435)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.cs	(revision 17436)
@@ -22,5 +22,5 @@
     private IList<JsonItemVMBase> VMs { get; set; }
     private JCGenerator Generator { get; set; } = new JCGenerator();
-    private IDictionary<string, IJsonItem> ResultItems = new Dictionary<string, IJsonItem>();
+    private IDictionary<string, IJsonItem> ResultItems { get; set; } = new Dictionary<string, IJsonItem>();
 
     private IContent content;
@@ -33,5 +33,6 @@
         treeView.Nodes.Clear();
         ResultItems.Clear();
-        
+        resultItems.Items.Clear();
+
         Optimizer = content as IOptimizer;
         Root = JsonItemConverter.Extract(Optimizer);
@@ -93,5 +94,5 @@
 
       if (SaveFileDialog.ShowDialog() == DialogResult.OK) {
-        File.WriteAllText(SaveFileDialog.FileName, Generator.GenerateTemplate(Root, Optimizer));
+        Generator.GenerateTemplate(@"C:\Users\p41997\Desktop", "template", Optimizer, Root);
       }
 
Index: /branches/3026_IntegrationIntoSymSpace/Heuristiclab.ConfigStarter/Program.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/Heuristiclab.ConfigStarter/Program.cs	(revision 17435)
+++ /branches/3026_IntegrationIntoSymSpace/Heuristiclab.ConfigStarter/Program.cs	(revision 17436)
@@ -46,6 +46,5 @@
 
       JCGenerator generator = new JCGenerator();
-
-      File.WriteAllText(@"C:\Workspace\Template.json", generator.GenerateTemplate(alg));
+      generator.GenerateTemplate(@"C:\Workspace\Template.json", alg);
       JsonTemplateInstantiator.Instantiate(@"C:\Workspace\Template.json");
       /*