Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/JsonItemBaseControl.Designer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/JsonItemBaseControl.Designer.cs	(revision 17439)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/JsonItemBaseControl.Designer.cs	(revision 17443)
@@ -60,5 +60,5 @@
       this.textBoxActualName.Location = new System.Drawing.Point(92, 75);
       this.textBoxActualName.Name = "textBoxActualName";
-      this.textBoxActualName.Size = new System.Drawing.Size(404, 20);
+      this.textBoxActualName.Size = new System.Drawing.Size(402, 20);
       this.textBoxActualName.TabIndex = 12;
       // 
@@ -79,5 +79,5 @@
       this.textBoxName.Location = new System.Drawing.Point(92, 23);
       this.textBoxName.Name = "textBoxName";
-      this.textBoxName.Size = new System.Drawing.Size(404, 20);
+      this.textBoxName.Size = new System.Drawing.Size(402, 20);
       this.textBoxName.TabIndex = 10;
       // 
@@ -107,5 +107,5 @@
       this.textBoxDescription.Location = new System.Drawing.Point(92, 49);
       this.textBoxDescription.Name = "textBoxDescription";
-      this.textBoxDescription.Size = new System.Drawing.Size(404, 20);
+      this.textBoxDescription.Size = new System.Drawing.Size(402, 20);
       this.textBoxDescription.TabIndex = 14;
       // 
@@ -124,5 +124,5 @@
       this.Name = "JsonItemBaseControl";
       this.Padding = new System.Windows.Forms.Padding(3);
-      this.Size = new System.Drawing.Size(502, 154);
+      this.Size = new System.Drawing.Size(500, 154);
       this.ResumeLayout(false);
       this.PerformLayout();
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/JsonItemBaseControl.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/JsonItemBaseControl.cs	(revision 17439)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/JsonItemBaseControl.cs	(revision 17443)
@@ -16,5 +16,5 @@
       InitializeComponent();
     }
-
+    
     public JsonItemBaseControl(JsonItemVMBase vm) {
       InitializeComponent();
@@ -31,4 +31,5 @@
       else
         textBoxActualName.Text = VM.Item.ActualName;
+        
     }
   }
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/SingleValueVM.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/SingleValueVM.cs	(revision 17439)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/SingleValueVM.cs	(revision 17443)
@@ -14,5 +14,5 @@
     protected override int MaxTypeValue => int.MaxValue;
 
-    public override JsonItemBaseControl GetControl() => 
+    public override JsonItemBaseControl GetControl() =>
       new JsonItemIntValueControl(this);
   }
@@ -24,5 +24,5 @@
     protected override double MaxTypeValue => double.MaxValue;
 
-    public override JsonItemBaseControl GetControl() => 
+    public override JsonItemBaseControl GetControl() =>
        new JsonItemDoubleValueControl(this);
   }
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/StringValueVM.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/StringValueVM.cs	(revision 17439)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/StringValueVM.cs	(revision 17443)
@@ -20,5 +20,5 @@
 
     public IEnumerable<string> Range {
-      get => Item.Range.Cast<string>();
+      get => Item.Range?.Cast<string>();
       set {
         Item.Range = value;
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.Designer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.Designer.cs	(revision 17439)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.Designer.cs	(revision 17443)
@@ -38,4 +38,5 @@
       this.tabPage2 = new System.Windows.Forms.TabPage();
       this.jsonItemBindingSource = new System.Windows.Forms.BindingSource(this.components);
+      this.treeViewResults = new System.Windows.Forms.TreeView();
       this.groupBoxDetails.SuspendLayout();
       this.groupBox2.SuspendLayout();
@@ -111,7 +112,7 @@
             | System.Windows.Forms.AnchorStyles.Right)));
       this.resultItems.FormattingEnabled = true;
-      this.resultItems.Location = new System.Drawing.Point(6, 19);
+      this.resultItems.Location = new System.Drawing.Point(6, 364);
       this.resultItems.Name = "resultItems";
-      this.resultItems.Size = new System.Drawing.Size(777, 499);
+      this.resultItems.Size = new System.Drawing.Size(777, 154);
       this.resultItems.TabIndex = 5;
       // 
@@ -134,4 +135,5 @@
             | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
+      this.groupBox3.Controls.Add(this.treeViewResults);
       this.groupBox3.Controls.Add(this.resultItems);
       this.groupBox3.Location = new System.Drawing.Point(6, 6);
@@ -199,4 +201,12 @@
       // 
       this.jsonItemBindingSource.DataSource = typeof(HeuristicLab.JsonInterface.IJsonItem);
+      // 
+      // treeViewResults
+      // 
+      this.treeViewResults.CheckBoxes = true;
+      this.treeViewResults.Location = new System.Drawing.Point(6, 19);
+      this.treeViewResults.Name = "treeViewResults";
+      this.treeViewResults.Size = new System.Drawing.Size(777, 339);
+      this.treeViewResults.TabIndex = 6;
       // 
       // ExportJsonDialog
@@ -242,4 +252,5 @@
     private System.Windows.Forms.TabPage tabPage1;
     private System.Windows.Forms.TabPage tabPage2;
+    private System.Windows.Forms.TreeView treeViewResults;
   }
 }
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.cs	(revision 17439)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.cs	(revision 17443)
@@ -125,4 +125,5 @@
               if (c is ResultItem) {
                 resultItems.Items.Add(c.Name, true);
+                
                 ResultItems.Add(c.Name, c);
               } else {
@@ -154,4 +155,5 @@
           panel.Controls.Add(control);
           control.Width = panel.Width;
+          control.Height = panel.Height;
           control.Dock = DockStyle.Fill;
           control.Anchor = AnchorStyles.Top | AnchorStyles.Bottom | AnchorStyles.Left | AnchorStyles.Right;
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemBoolControl.Designer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemBoolControl.Designer.cs	(revision 17439)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemBoolControl.Designer.cs	(revision 17443)
@@ -52,5 +52,4 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.BackColor = System.Drawing.SystemColors.Control;
       this.Controls.Add(this.label2);
       this.Controls.Add(this.checkBoxValue);
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemRangeControl.Designer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemRangeControl.Designer.cs	(revision 17439)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemRangeControl.Designer.cs	(revision 17443)
@@ -102,5 +102,5 @@
       this.Controls.Add(this.groupBox1);
       this.Name = "JsonItemRangeControl";
-      this.Size = new System.Drawing.Size(500, 301);
+      this.Size = new System.Drawing.Size(500, 290);
       this.Controls.SetChildIndex(this.groupBox1, 0);
       this.Controls.SetChildIndex(this.numericRangeControl1, 0);
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.Designer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.Designer.cs	(revision 17439)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.Designer.cs	(revision 17443)
@@ -25,7 +25,7 @@
     private void InitializeComponent() {
       this.tableOptions = new System.Windows.Forms.TableLayoutPanel();
-      this.groupBoxRange = new System.Windows.Forms.GroupBox();
       this.comboBoxValues = new System.Windows.Forms.ComboBox();
       this.label2 = new System.Windows.Forms.Label();
+      this.groupBoxRange = new System.Windows.Forms.GroupBox();
       this.groupBoxRange.SuspendLayout();
       this.SuspendLayout();
@@ -33,31 +33,18 @@
       // tableOptions
       // 
-      this.tableOptions.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.tableOptions.AutoSize = true;
+      this.tableOptions.AutoScroll = true;
+      this.tableOptions.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
+      this.tableOptions.BackColor = System.Drawing.SystemColors.Control;
       this.tableOptions.ColumnCount = 2;
       this.tableOptions.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 20F));
       this.tableOptions.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
-      this.tableOptions.Location = new System.Drawing.Point(6, 19);
+      this.tableOptions.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+      this.tableOptions.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.tableOptions.Location = new System.Drawing.Point(3, 16);
       this.tableOptions.Name = "tableOptions";
       this.tableOptions.RowCount = 1;
       this.tableOptions.RowStyles.Add(new System.Windows.Forms.RowStyle());
-      this.tableOptions.Size = new System.Drawing.Size(478, 417);
+      this.tableOptions.Size = new System.Drawing.Size(482, 170);
       this.tableOptions.TabIndex = 12;
-      // 
-      // groupBoxRange
-      // 
-      this.groupBoxRange.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.groupBoxRange.AutoSize = true;
-      this.groupBoxRange.Controls.Add(this.tableOptions);
-      this.groupBoxRange.Location = new System.Drawing.Point(6, 128);
-      this.groupBoxRange.Name = "groupBoxRange";
-      this.groupBoxRange.Size = new System.Drawing.Size(490, 442);
-      this.groupBoxRange.TabIndex = 14;
-      this.groupBoxRange.TabStop = false;
-      this.groupBoxRange.Text = "Range";
       // 
       // comboBoxValues
@@ -69,5 +56,5 @@
       this.comboBoxValues.Location = new System.Drawing.Point(92, 101);
       this.comboBoxValues.Name = "comboBoxValues";
-      this.comboBoxValues.Size = new System.Drawing.Size(404, 21);
+      this.comboBoxValues.Size = new System.Drawing.Size(402, 21);
       this.comboBoxValues.TabIndex = 15;
       // 
@@ -81,20 +68,31 @@
       this.label2.Text = "Value";
       // 
+      // groupBoxRange
+      // 
+      this.groupBoxRange.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.groupBoxRange.Controls.Add(this.tableOptions);
+      this.groupBoxRange.Location = new System.Drawing.Point(6, 128);
+      this.groupBoxRange.Name = "groupBoxRange";
+      this.groupBoxRange.Size = new System.Drawing.Size(488, 189);
+      this.groupBoxRange.TabIndex = 17;
+      this.groupBoxRange.TabStop = false;
+      this.groupBoxRange.Text = "Range";
+      // 
       // JsonItemValidValuesControl
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.AutoSize = true;
+      this.Controls.Add(this.groupBoxRange);
       this.Controls.Add(this.label2);
       this.Controls.Add(this.comboBoxValues);
-      this.Controls.Add(this.groupBoxRange);
       this.ForeColor = System.Drawing.Color.Black;
       this.Name = "JsonItemValidValuesControl";
-      this.Size = new System.Drawing.Size(500, 576);
-      this.Controls.SetChildIndex(this.groupBoxRange, 0);
+      this.Size = new System.Drawing.Size(500, 323);
       this.Controls.SetChildIndex(this.comboBoxValues, 0);
       this.Controls.SetChildIndex(this.label2, 0);
+      this.Controls.SetChildIndex(this.groupBoxRange, 0);
       this.groupBoxRange.ResumeLayout(false);
-      this.groupBoxRange.PerformLayout();
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -104,7 +102,7 @@
     #endregion
     private System.Windows.Forms.TableLayoutPanel tableOptions;
-    private System.Windows.Forms.GroupBox groupBoxRange;
     private System.Windows.Forms.ComboBox comboBoxValues;
     private System.Windows.Forms.Label label2;
+    private System.Windows.Forms.GroupBox groupBoxRange;
   }
 }
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.cs	(revision 17439)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValidValuesControl.cs	(revision 17443)
@@ -14,8 +14,20 @@
     public JsonItemValidValuesControl(StringValueVM vm) : base(vm) {
       InitializeComponent();
-      foreach (var i in VM.Item.Range)
-        SetupOption((string)i);
-
-      comboBoxValues.DataBindings.Add("SelectedItem", VM, nameof(StringValueVM.Value));
+      if (VM.Item.Range != null) {
+        foreach (var i in VM.Item.Range)
+          SetupOption((string)i);
+        comboBoxValues.DataBindings.Add("SelectedItem", VM, nameof(StringValueVM.Value));
+      } else {
+        comboBoxValues.Hide();
+        groupBoxRange.Hide();
+        TextBox tb = new TextBox();
+        this.Controls.Add(tb);
+        tb.Location = comboBoxValues.Location;
+        tb.Size = comboBoxValues.Size;
+        tb.Anchor = comboBoxValues.Anchor;
+        tb.Dock = comboBoxValues.Dock;
+        tb.DataBindings.Add("Text", VM, nameof(StringValueVM.Value));
+        tb.Show();
+      }
     }
     
@@ -24,6 +36,7 @@
       TextBox tb = new TextBox();
       tb.Text = opt;
+      //tb.Size = new Size()
       tb.Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right;
-      tb.Size = new Size(420, 20);
+      //tb.Dock = DockStyle.Right | DockStyle.Left;
       tb.ReadOnly = true;
 
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValueControl.Designer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValueControl.Designer.cs	(revision 17439)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValueControl.Designer.cs	(revision 17443)
@@ -35,5 +35,5 @@
       this.textBoxValue.Location = new System.Drawing.Point(92, 101);
       this.textBoxValue.Name = "textBoxValue";
-      this.textBoxValue.Size = new System.Drawing.Size(404, 20);
+      this.textBoxValue.Size = new System.Drawing.Size(402, 20);
       this.textBoxValue.TabIndex = 14;
       // 
@@ -53,5 +53,5 @@
       this.numericRangeControl1.Location = new System.Drawing.Point(9, 127);
       this.numericRangeControl1.Name = "numericRangeControl1";
-      this.numericRangeControl1.Size = new System.Drawing.Size(487, 112);
+      this.numericRangeControl1.Size = new System.Drawing.Size(485, 112);
       this.numericRangeControl1.TabIndex = 16;
       // 
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValueControl.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValueControl.cs	(revision 17439)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemValueControl.cs	(revision 17443)
@@ -13,9 +13,9 @@
   
   public class JsonItemIntValueControl : JsonItemValueControl {
-
+    
     #region Overriden Properties
     protected override string ValuePropertyId => nameof(IntValueVM.Value);
     #endregion
-
+    
     public JsonItemIntValueControl(IntValueVM vm) : base(vm) {
       Init();
@@ -24,5 +24,5 @@
 
   public class JsonItemDoubleValueControl : JsonItemValueControl {
-
+    
     #region Overriden Properties
     protected override string ValuePropertyId => nameof(DoubleValueVM.Value);
@@ -49,5 +49,5 @@
       NumericRangeControl = numericRangeControl1;
     }
-
+    
     protected void Init() {
       TBValue.DataBindings.Add("Text", base.VM, ValuePropertyId);