Index: /branches/3040_VectorBasedGP/HeuristicLab.ExtLibs.sln
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.ExtLibs.sln	(revision 17446)
+++ /branches/3040_VectorBasedGP/HeuristicLab.ExtLibs.sln	(revision 17447)
@@ -86,4 +86,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Protobuf", "HeuristicLab.ExtLibs\HeuristicLab.Protobuf\3.6.1\HeuristicLab.Protobuf.csproj", "{44B10478-D290-43D3-9757-C08F5292FEA5}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.MathNet.Numerics", "HeuristicLab.MathNet.Numerics\HeuristicLab.MathNet.Numerics.csproj", "{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}"
 EndProject
 Global
@@ -561,4 +563,16 @@
 		{44B10478-D290-43D3-9757-C08F5292FEA5}.Release|x86.ActiveCfg = Release|Any CPU
 		{44B10478-D290-43D3-9757-C08F5292FEA5}.Release|x86.Build.0 = Release|Any CPU
+		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Debug|x64.Build.0 = Debug|Any CPU
+		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Debug|x86.Build.0 = Debug|Any CPU
+		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Release|Any CPU.Build.0 = Release|Any CPU
+		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Release|x64.ActiveCfg = Release|Any CPU
+		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Release|x64.Build.0 = Release|Any CPU
+		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Release|x86.ActiveCfg = Release|Any CPU
+		{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}.Release|x86.Build.0 = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: /branches/3040_VectorBasedGP/HeuristicLab.MathNet.Numerics/HeuristicLab.MathNet.Numerics.csproj
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.MathNet.Numerics/HeuristicLab.MathNet.Numerics.csproj	(revision 17447)
+++ /branches/3040_VectorBasedGP/HeuristicLab.MathNet.Numerics/HeuristicLab.MathNet.Numerics.csproj	(revision 17447)
@@ -0,0 +1,64 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="15.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProjectGuid>{71AE8AE6-F1A5-445C-AD31-AFFC83CE2E28}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.MathNet.Numerics</RootNamespace>
+    <AssemblyName>HeuristicLab.MathNet.Numerics</AssemblyName>
+    <TargetFrameworkVersion>v4.7</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <Deterministic>true</Deterministic>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="Plugin.cs.frame" />
+    <Compile Include="Plugin.cs" />
+    <None Include="Properties\AssemblyInfo.cs.frame" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj">
+      <Project>{94186a6a-5176-4402-ae83-886557b53cca}</Project>
+      <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <PackageReference Include="MathNet.Numerics">
+      <Version>4.9.0</Version>
+    </PackageReference>
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd
+</PreBuildEvent>
+  </PropertyGroup>
+</Project>
Index: /branches/3040_VectorBasedGP/HeuristicLab.MathNet.Numerics/Plugin.cs.frame
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.MathNet.Numerics/Plugin.cs.frame	(revision 17447)
+++ /branches/3040_VectorBasedGP/HeuristicLab.MathNet.Numerics/Plugin.cs.frame	(revision 17447)
@@ -0,0 +1,33 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.MathNet.Numerics {
+  [Plugin("HeuristicLab.MathNet.Numerics", "HeuristicLab wrapper for MathNet.Numerics nuget package.", "4.9.0.$WCREV$")]
+  [PluginFile("HeuristicLab.MathNet.Numerics", PluginFileType.Assembly)]
+  [PluginFile("MathNet.Numerics.dll", PluginFileType.Assembly)]
+  //[PluginFile("MathNet.Numerics.License.txt", PluginFileType.License)]
+  public class Plugin : PluginBase {
+    public Plugin() {
+    }
+  }
+}
Index: /branches/3040_VectorBasedGP/HeuristicLab.MathNet.Numerics/Properties/AssemblyInfo.cs.frame
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.MathNet.Numerics/Properties/AssemblyInfo.cs.frame	(revision 17447)
+++ /branches/3040_VectorBasedGP/HeuristicLab.MathNet.Numerics/Properties/AssemblyInfo.cs.frame	(revision 17447)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.MathNet.Numerics")]
+[assembly: AssemblyDescription("Provides an interface to MathNet.Numerics nuget package")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible
+// to COM components.  If you need to access a type in this assembly from
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("71ae8ae6-f1a5-445c-ad31-affc83ce2e28")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("4.9.0")]
+[assembly: AssemblyFileVersion("4.9.0.$WCREV$")]